LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;	  

ENTITY cardcounter IS
   
   PORT(clock 		: IN	STD_LOGIC;
   		reset  		: IN    STD_LOGIC;		
   		issued		: IN	STD_LOGIC;
   		card		: IN	STD_LOGIC_VECTOR (3 downto 0);
	  	stat_ace 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_two 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_three 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_four 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_five 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_six 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_seven 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_eight 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_nine 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_ten 	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_jack	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_queen	: OUT 	STD_LOGIC_VECTOR (4 downto 0);
		stat_king 	: OUT 	STD_LOGIC_VECTOR (4 downto 0)

   );  
   
END cardcounter;

--
ARCHITECTURE cc_arch OF cardcounter IS	 

		signal ace	 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal two 		: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal three 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal four 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal five 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal six 		: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal seven 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal eight 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal nine 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal ten 		: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal jack		: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal queen	: STD_LOGIC_VECTOR (4 downto 0):= "00000";
		signal king 	: STD_LOGIC_VECTOR (4 downto 0):= "00000";

BEGIN
   	process(reset,issued)	
	begin
   	--	if clock'event and clock = '0' then
      		if reset'event and reset = '1' then 
				ace <= "00000"; two <= "00000"; three <= "00000"; four <= "00000";
				five <= "00000"; six <= "00000"; seven <= "00000"; eight <= "00000";
				nine <="00000"; ten <= "00000"; jack<= "00000"; queen <= "00000";
				king <= "00000";	  
			else
				if issued'event and issued = '1' then
				case card is
					when "0001" =>
					ace <= ace + 1;
					when "0010" =>
					two <= two + 1;
					when "0011" =>
					three <= three + 1;
					when "0100" =>
					four <= four + 1;
					when "0101" =>
					five <= five + 1;
					when "0110" =>
					six <= six + 1;
					when "0111" =>
					seven <= seven + 1;
					when "1000" =>
					eight <= eight + 1;
					when "1001" =>
					nine <= nine + 1;
					when "1010" =>
					ten <= ten + 1;
					when "1011" =>
					jack <= jack + 1;
					when "1100" =>
					queen <= queen + 1;
					when "1101" =>
					king <= king + 1;
					when OTHERS =>
					
					end case;
					end if;
			end if;
	end process;	
	stat_ace <= ace; stat_two <= two; stat_three <= three; stat_four <= four; stat_five <= five; stat_six <=six;
	stat_seven <= seven; stat_eight <= eight; stat_nine <= nine; stat_ten <= ten; stat_jack <= jack; 
	stat_queen <= queen; stat_king <= king;

END cc_arch;
